# USVLander

## 项目介绍
USVLander 是一个完全基于计算机视觉的无人机控制算法，目前针对 DJI Tello 无人机设计，能够实现视觉自主降落至无人船。该项目基于 Python 编程语言，并集成了 YOLO 实时目标检测系统和 OpenCV 计算机视觉库，以提供精确的导航和控制。

![控制流程草图](docs/Draft_process.png)

## 安装说明
要安装 USVLander，您需要确保您的系统中已安装 Python 3.10 或更高版本（开发过程基于 Python3.10.8 ）。此外，您还需要安装 YOLO 和 OpenCV 库。可以通过以下命令安装所需的依赖项：

```bash
pip install -r requirements.txt
```

## 如何使用
在安装所有必要的依赖项后，您可以通过以下步骤使用 USVLander 控制算法：

1. 将计算机连接到 DJI Tello 无人机的 Wi-Fi 热点。（一般为 Tello-XXXXXX）。
2. 打开终端并导航到 USVLander 项目目录。
3. 运行主控制脚本：


```bash
python agent.py
```

程序启动后，无人机将在延迟 5 秒后起飞，上升至距地面 2 m，然后开始搜索无人船。在开发阶段，基于 YOLO 的目标检测并未实装，因此需要使用“人工智能”，由操作者手动在弹出的 `ROI Select` 窗口中选择无人船的位置，并使用 `空格键`确认。选择完成后，程序将自动计算无人机与无人船之间的距离，并对无人船的追踪。

在无人机底部摄像头检测到无人船上的 Apriltag 后，无人机将开始降落。在降落过程中，无人机将尝试保持在无人船正上方，并在降落过程中调整自身位置，以确保安全降落。

### 

## License
USVLander 根据 MIT 许可证发布。这意味着您可以自由地使用、修改和分发该软件，但您必须包含原始作者的版权声明和许可声明。

请注意，此 README 是一个基本模板，您可能需要根据项目的具体情况进行调整。确保在发布之前，您已经完全测试了所有的功能，并且代码的文档是最新的。


